import { Component, OnInit } from '@angular/core';


import { ToastrService } from 'ngx-toastr';
import { ActivatedRoute, Router } from '@angular/router';
import { College } from 'src/app/models/fnd/play';
import { student } from 'src/app/models/fnd/Studentadd';
import { FormBuilder, FormGroup, Validators } from '@angular/forms';
import { ValidationError } from 'src/app/models/fnd/ValidationError';
import { test1service } from './test1.service';
import { Observable } from 'rxjs';
@Component({
  selector: 'app-editstepper',
  templateUrl: './test1.component.html',
  styleUrls: ['./test1.component.scss']
})
export class test1Component implements OnInit {
  updated = false;
  // college: College;
  stringJson: any;
  customerId: string = '';
  selectedFile!: File;
  fileName = '';

  id: number;
  errorFields: ValidationError[] = [];
  appToUpdate: College = null;
  trained = false;

  json: string = "";
  luisApp =
    {
      name: '',
      created: 1,
      trained: 1,
      tested: 1,
      updated: 1,
      published: 1,

    };
  // Layout direction changing
  layout = {
    direction: "vertical",
    block1: "clr-col-lg-3 clr-col-12 ",
    block2: "clr-col-lg-9 clr-col-12 ",
  };

  timelineStyle = {
    step0: { state: "current", open: true, failed: false },
    step1: { state: "not-started", open: false, failed: false },
    step2: { state: "not-started", open: false, failed: false },

  };
  public test1entryForm: FormGroup;
  public test2entryForm: FormGroup;
  submitted = false;
  rowSelected: any = {};
  modalcomplete = false;

  constructor(private mainService: test1service,

    private test1_fb: FormBuilder,
    private test2_fb: FormBuilder,
    private router: Router,
    private route: ActivatedRoute,
    private toastr: ToastrService,
  ) { }

  ngOnInit(): void {
    // this.college = new College();
    this.id = this.route.snapshot.params["id"];
    console.log("update with id = ", this.id);

    this.test1entryForm = this.test1_fb.group({
      name: [null],

      description: [null],

      active: [false],

    });

    this.test2entryForm = this.test2_fb.group({
      name: [null],

      description: [null],

    });
    const stepId = this.id; // or from route/query/etc
    this.getResolvedDataFromStepper(stepId).subscribe(res => {
      console.log('response get ', res);

      if (res === null) {
        this.showEmptyForm();
      } else {
        if (res['Test2']) {
          this.prefillTest1Form(res['Test2']);
        }

        if (res['Basicp']) {
          this.prefillTest2Form(res['Basicp']);
        }
        
      }
    });


  }

  showEmptyForm(): void {
    console.log('No config found. Showing empty form.');
    // You can choose to show one or both based on some logic
    this.test1entryForm.reset();
    this.test2entryForm.reset();
  }

  prefillTest1Form(data: any): void {

    console.log(' test1 data ', data)
    this.test1entryForm.patchValue({
      id: data.id || '',
      name: data.name || '',
      description: data.description || '',
      active: data.active || false
    });
  }

  prefillTest2Form(data: any): void {
    console.log(' test2 data ', data)

    this.test2entryForm.patchValue({
      id: data.id || '',
      name: data.name || '',
      description: data.description || ''
    });
  }


  getResolvedDataFromStepper(id: number): Observable<any> {
    console.log('get step config');

    return new Observable(observer => {
      this.mainService.gettabledata(id).subscribe(configList => {
        if (!configList || configList.length === 0) {
          console.log('empty config');
          observer.next(null);
          observer.complete();
          return;
        }

        const results: { [key: string]: any } = {};
        let processed = 0;

        configList.forEach(config => {
          const { table_name, table_id } = config;

          this.getByTableNameAndId(table_name, table_id).subscribe(data => {

            console.log('data is ', data);
            results[table_name] = data;

            processed++;
            if (processed === configList.length) {
              observer.next(results);  // emit combined data
              observer.complete();
            }

          }, error => {
            console.error(`Error loading data for table ${table_name}`, error);
            processed++;
            if (processed === configList.length) {
              observer.next(results);  // continue with what we have
              observer.complete();
            }
          });
        });

      }, error => {
        console.error("Error loading stepper config", error);
        observer.error(error);
      });
    });
  }



  getByTableNameAndId(tableName: string, id: number): Observable<any> {

    switch (tableName) {
      case 'Test2':
        return this.mainService.getTest2ById(id);
      case 'Basicp':
        return this.mainService.getBasicpById(id);
      // aur bhi cases agar naye table add ho to
      default:
        throw new Error(`Unknown table name: ${tableName}`);
    }
  }

  // Change to Horizontal Layout
  changeToHorizonTal() {
    this.layout = {
      direction: "horizontal",
      block1: "clr-col-lg-12 clr-col-12 height container",
      block2: "clr-col-lg-12 clr-col-12 container",
    }
  }
  // Change to Vertical Layout
  changeToVertical() {
    this.layout = {
      direction: "vertical",
      block1: "clr-col-lg-3 clr-col-12 ",
      block2: "clr-col-lg-9 clr-col-12 ",
    }
  }



  ontest1Save() {
    console.log('Form Submitted:', this.test1entryForm.value);
    this.submitted = true;
    if (this.test1entryForm.invalid) {

      console.log('invalid form ..');
      // Log all form errors
      Object.keys(this.test1entryForm.controls).forEach(field => {
        const control = this.test1entryForm.get(field);
        if (control && control.invalid) {
          console.log(`Error in field: ${field}`, control.errors);
        }
      }
      );
      return;
    }
    this.ontest1Create();
  }

  ontest1Create() {
    this.mainService.createTest2(this.test1entryForm.value).subscribe(
      (data) => {
        console.log('adding data ', data);
        this.customerId = data.id;

        console.log('id is  ', this.customerId);
        const tableId = data.id;
        const tableName = 'Test2';
        const stepperId = this.id;

        // Save stepper config
        this.mainService.saveStepperConfig(stepperId, tableId, tableName).subscribe(() => {
          this.toastr.success("Stepper Config Saved");
        });

        if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Added Successfully");
        }
        setTimeout(() => {
          this.ngOnInit();
        }, 500);

      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("Added Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Added");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Added");
        }
      });
    this.rowSelected = this.test1entryForm.value;

    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  }


  ontest2Save() {
    console.log('Form Submitted:', this.test2entryForm.value);
    this.submitted = true;
    if (this.test2entryForm.invalid) {

      console.log('invalid form ..');
      // Log all form errors
      Object.keys(this.test2entryForm.controls).forEach(field => {
        const control = this.test2entryForm.get(field);
        if (control && control.invalid) {
          console.log(`Error in field: ${field}`, control.errors);
        }
      }
      );
      return;
    }
    this.ontest2Create();
  }

  ontest2Create() {
    this.mainService.createBasicp(this.test2entryForm.value).subscribe(
      (data) => {
        console.log('adding data ', data);
        this.customerId = data.id;

        console.log('id is  ', this.customerId);

        const tableId = data.id;
        const tableName = 'Basicp';
        const stepperId = this.id;

        // Save stepper config
        this.mainService.saveStepperConfig(stepperId, tableId, tableName).subscribe(() => {
          this.toastr.success("Stepper Config Saved");
        });

        if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Added Successfully");
        }
        setTimeout(() => {
          this.ngOnInit();
        }, 500);

      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("Added Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Added");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Added");
        }
      });
    this.rowSelected = this.test2entryForm.value;

    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  }


  onnext() {
    this.router.navigate(["../../main/workflow"], { relativeTo: this.route });
  }
  reset() {
    this.json = "";
    this.luisApp =
    {
      name: '',
      trained: 1,
      tested: 1,
      updated: 1,
      published: 1,
      created: 1,

    };

    this.timelineStyle = {
      step0: { state: "current", open: true, failed: false },
      step1: { state: "not-started", open: false, failed: false },
      step2: { state: "not-started", open: false, failed: false },

    };
  }
  current() {
    console.log(this.timelineStyle)
    this.stringJson = JSON.stringify(this.timelineStyle);
    console.log("String json object :", this.stringJson);

    // this.mainService.update(this.id, this.college, this.stringJson).subscribe(
    //   (data) => {
    //     console.log(data);
    //   },

    // );
  }


  rsModaldescription = false;
  goToReplaceStringdescription(row) {
    this.rowSelected = row; this.rsModaldescription = true;
  }

  // updateaction
}